#ifndef GAMEWINDOW_H
#define GAMEWINDOW_H

#include <QMainWindow>
#include <QKeyEvent>
#include <QPainter>
#include <Qfile>
#include <QTextStream>

typedef struct tpoint{
    unsigned char x;
    unsigned char y;
} tpoint;

typedef struct titlePoints{
    double x;
    double y;
    double z;
    double w;
} titlePoints;


class GameWindow : public QMainWindow
{
    Q_OBJECT
public:
    explicit GameWindow(QWidget *parent = 0);
    ~GameWindow();

private:
    //void rotZ(titlePoints *t, double r1, double r2);
    void writeStart(void);
    void writeEndOfSector(void);
    void writeChar(unsigned char ch);
    void writePalette(int *palData);
    void writeFont(unsigned char *fontData);
    void writeVramFromMap(char map[][3]);
    void writeVramFromText(unsigned char map[]);
    void titleScreen(void);
    int drawSceneWebMovie(void);
    void drawScene3(void);
    int  drawSceneSpinDemonWeb(void);
    int  drawSceneTextSwirl(void);
    void rotateText(QPainter *qp, double r, double s, int x, int y);
    void getWebPoints(int web, int lane, int *x0, int *y0, int *x1, int *y1);
    void getWebPointsPan(int web, int lane, int *x0, int *y0, int *x1, int *y1);
    void GetLaneMiddle(int web, int lane, char *sX, char *sY);
    void GetLaneMultipliers(int web, int lane, char *sX, char *sY, char *mX, char *mY);
    void getLaneAngle(int web, int lane, unsigned char *theta);
    void WriteWebAngles(void);
    void getClawOffset(int web, int r, int *xClaw, int *yClaw);
    void getClawOffsetAvg(int web, int r, int numPoints, int *xClaw, int *yClaw);
    void ZShift(int *x0, int *y0, int z0, int *x1, int *y1);

    char fontTranslate(unsigned char ascii, unsigned char fontNum);

    void paintEvent(QPaintEvent *event);
    void timerEvent(QTimerEvent *event);
    void keyPressEvent(QKeyEvent *event);
    void openFile(void);
    void closeFile(void);
    void writeImage(void);


    void myDrawLine(QPainter *qp, int x1, int y1, int x2, int y2, int col);
    void myDrawLine2(QPainter *qp, int x1, int y1, int x2, int y2, int col);

    void myDrawLineV(QPainter *qp, int x1, int y1, int x2, int y2);
    void myDrawLineH(QPainter *qp, int x1, int y1, int x2, int y2);
    void myDrawLineQ1(QPainter *qp, int x1, int y1, int x2, int y2);
    void myDrawLineQ2(QPainter *qp, int x1, int y1, int x2, int y2);
    void myDrawLineQ3(QPainter *qp, int x1, int y1, int x2, int y2);
    void myDrawLineQ4(QPainter *qp, int x1, int y1, int x2, int y2);

    QImage playfield;
    QImage playfield2;

    QPen myPen[4];

    QFile myFile;
    int WriteFile;
    int bytesWritten;

    int webDx;
    int webDy;
    int level;
    int zoom;
    int r;

    int xClaw, yClaw;

protected:

signals:

public slots:

};

#endif // GAMEWINDOW_H
